; Author :   (for_dgf@mail.ru)
;  . , .
;   26.08.2021
.Dseg
.org 0x100
;**************************************  
.equ	DH1Event	= 0x01				;      Event
.equ	DH2Event	= 0x10
.equ	SystemClk	= 7				;   
                                                        ;         .

.equ	Ka		= 2*int((Base-_Delta)/_Delta)	; 
;      
.equ	UOZMaxFP8tmp	= int(Ka*(_Delta+_Betta-_UOZMin)/(Base-_Delta)*128+0.5)		
;<=255
.equ	UOZMaxFP8   	= 255*(UOZMaxFP8tmp>255)+UOZMaxFP8tmp*(255>=UOZMaxFP8tmp)
;       
.equ	UOZMinFP8tmp	= int(Ka*(_Delta+_Betta-_UOZMax)/(Base-_Delta)*128+0.5)				
;>=0
.equ	UOZMinFP8	= UOZMinFP8tmp*(UOZMinFP8tmp>0)
;       
.equ	CorrectFP16tmp	= int(Ka*_Manual/(Base-_Delta)*32768+0.5)
;   _Delta/2
.equ	CorrectFP16Max	= int(Ka*_Delta/(Base-_Delta)*32768/2+0.5) 
.equ	CorrectFP16	= CorrectFP16Max*(CorrectFP16tmp>CorrectFP16Max)+CorrectFP16tmp*(CorrectFP16Max>=CorrectFP16tmp)
;      
.equ	LoadFP16tmp 	= int(Ka*_Load/(Base-_Delta)*32768+0.5)
;  10 .
.equ	LoadFP16Max	= int(Ka*10/(Base-_Delta)*32768+0.5)
.equ	LoadFP16	= LoadFP16Max*(LoadFP16tmp>LoadFP16Max)+LoadFP16tmp*(LoadFP16Max>=LoadFP16tmp)
;         
.equ	StopTimetmp	= int(_StopTime*122.0703125/(1+Fn)+0.5)
;<=255
.equ	StopTime   	= 255*(StopTimetmp>255)+StopTimetmp*(255>=StopTimetmp)
;           
.equ	Alfatmp 	= int(_Alfa/_Delta*256+0.5)                   	                             
;  Base-_Delta
.equ	AlfaMax		= int((Base-_Delta)/_Delta*256+0.5)  
.equ	Alfa		= AlfaMax*(Alfatmp>AlfaMax)+Alfatmp*(AlfaMax>=Alfatmp)
;**************************************  
UOZ:			.byte	32*TblCount		;FP8.    ( 32 ).
Index:			.byte	64			;  
UOZCurrent:		.byte	2			;FP16.  . 
TblSelectr:		.byte	1			;     UOZ
TblAddress:		.byte	2			;     UOZ
StopCnt:		.byte	1            		;    
Rbuff:			.byte	256			;   
Tbuff:			.byte	256			;   
RptrI:			.byte	1			;     
RptrO:			.byte	1			;       RptrO=RptrI,     !!!
TptrI:			.byte	1			;     
TptrO:			.byte	1			;       TptrO=TptrI,     !!!
TableUART:		.byte	1			;  /   UART
ADCBuffers:		.byte	4*ADCBufferSize	  	;    
ADCptrNew:		.byte	1			;      . 
ADCptr:			.byte	1			;     . 
ADCAver:		.byte	8			;    ,    
tester:			.byte	2			;  
MDelta:			.byte	2			;   DELTA
EOCR1B:                 .byte	3			;  OCR1B
Version: 		.byte	66  			;   +    64 +0
DivPtr:			.byte	2			;     Ka 2-128


LoadBuffer:		.byte	LoadBufferSize	  	;   
Loadptr:		.byte	1			;     

PLoad:			.byte   2                       ;   
PCorr:			.byte	3			;   

FAcc:			.byte	1			; 5 
FA:			.byte	2			;   FLASH


EndCoreDseg:						;    

.CSEG
.org 0x00								
	jmp	ResetCore				;  bootsection Bootrst =  (0) 300h    . 
	jmp	LinesCNHG				;   PD2 (IRQ0)
	jmp	LinesCNHG				;   PD3 (IRQ1)
	jmp	EmptyInt				;PCINT0
	jmp	EmptyInt				;PCINT1
	jmp	EmptyInt				;PCINT2
	jmp	EmptyInt				;Watchdog Timer
	jmp	ProtectLines				;     Timer2 (Compare A)
	jmp	EmptyInt				;Timer2 Compare B
	jmp	EmptyInt				;Timer2 Overflow
	jmp	EmptyInt				;Timer1 Capture
	jmp	IgnitionInt				; Timer1 Compare A
	jmp	ServiceInt				;  Timer1 Compare B
	jmp	EmptyInt				;Timer1 Overflow
	jmp	EmptyInt				;Timer0 Compare A
	jmp	EmptyInt				;Timer0 Compare B
	jmp	EmptyInt				;Timer0 Overflow
	jmp	EmptyInt				;SPI Transfer Complete
	jmp	RX_OK					;USART, RX Complete
	jmp	EmptyInt				;USART, UDR Empty
	jmp	EmptyInt				;USART, TX Complete
	jmp	EmptyInt				;ADC Conversion Complete
	jmp	EmptyInt				;EEPROM Ready Handler
	jmp	EmptyInt				;Analog Comparator Handler
	jmp	EmptyInt				;2-wire Serial Interface Handler
	jmp	EmptyInt				;Store Program Memory Ready Handler
EmptyInt:	reti
		.db 0,1,2,3,4,5,6,7,8,9
VersionPtr:	.db VersionName,'\0',0,0,0,0

;*******************************************************************************
.def    Status		= r24				; 
.equ	LowModeBit	= 0x07                          ;7 LowMode  -    
.equ	StopModeBit	= 0x06                          ;6 StopMode -  
.equ	UOZMaxBit	= 0x05                          ;5 UOZMax   -  UOZ   
.equ	UOZMinBit	= 0x04			        ;4 UOZMin   -  UOZ  
.equ	DH2Bit		= 0x03		                ;3 DH2	    -   PD3(int1)
.equ	DH1Bit		= 0x02                          ;2 DH1	    -   PD2(int0)
.equ	ProtectBit	= 0x01                          ;1 Protect  -       
.equ	UARTCtrlBit	= 0x00                          ;0 UARTCtrl -   TblSelectr: 0 -   (), 1 -  UART
.equ	LowMode		= (1<<LowModeBit)
.equ	StopMode	= (1<<StopModeBit)
.equ	UOZMax		= (1<<UOZMaxBit)
.equ	UOZMin		= (1<<UOZMinBit)
.equ	DH2		= (1<<DH2Bit)
.equ	DH1		= (1<<DH1Bit)
.equ	Protect		= (1<<ProtectBit)
.equ	UARTCtrl	= (1<<UARTCtrlBit)
;*******************************************************************************
.def    EStatus		= r25				;  
.equ	RErrorBit	= 0x07				;7 RError   -   
.equ	RnewCMDBit	= 0x06				;6 RnewCMD  -     
.equ	TErrorBit	= 0x05				;5 TError   -   
.equ	TnotEmptyBit	= 0x04				;4 TnotEmpty -     	 
.equ    EOCR1BEmptyBit	= 0x03				;3 EOCR1BEmpty -   EOCR1B 
.equ    Ign2Bit		= 0x02				;2 Ign2 -   2
.equ    Ign1Bit		= 0x01				;1 Ign1 -   1
.equ	DeltaBit	= 0x00				;0 Delta    -   Delta
.equ	RError		= (1<<RErrorBit)                          
.equ	RnewCMD		= (1<<RnewCMDBit)
.equ	TError		= (1<<TErrorBit)
.equ	TnotEmpty	= (1<<TnotEmptyBit)
.equ	EOCR1BEmpty	= (1<<EOCR1BEmptyBit)
.equ	Ign2		= (1<<Ign2Bit)
.equ	Ign1		= (1<<Ign1Bit)
.equ	Delta		= (1<<DeltaBit)
;******************************************************   (: in, out,  Load  Store, sbi, cbi, sbic, sbis)
.equ	CoreSetup	  = GPIOR0		        ; 
.equ	DH2DisableBit	  = 0x07			;7 -   DH2.      0 
.equ	AverageDisableBit = 0x06			;6 -      N
.equ	ServiceADisableBit= 0x05			;5 -    ServiceA
.equ	ServiceBDisableBit= 0x04			;4 -    ServiceB
.equ	C3734DisableBit	  = 0x03			;3 -     .37.34
.equ	LoadDisableBit	  = 0x02			;2 -   
.equ	ADCDisableBit	  = 0x01			;1 -   
.equ	UARTDisableBit	  = 0x00			;0 -  UART


;*******************************************************************************
.equ	ECoreSetup	= GPIOR1			;   (    Load/Store   lds/sts)
							;7 -  7  
							;6 -  6  
							;5 -  5  
							;4 -  4  
							;3 - LEDCrtl3 
							;2 - LEDCrtl2 
							;1 - LEDCrtl1 
;LEDCrtl[3..0]	    Arduino	;0 - LEDCrtl0 
;0 		- 
;1 		- Delta
;2 		- CPU D2(PD2)
;3 		- CPU D3(PD3)
;4 		- CPU A3(PC3)
;5 		- CPU A2(PC2)
;6 		- CPU A1(PC1)
;7 		- CPU A0(PC0)
;8 		- 
;9 		-  
;10		-  .
;11		-  .
;12		-   Ign1
;13		-   Ign2
;14		- UARTCtrl
;15		- 
;*******************************************************************************
.equ	RCoreSetup	= GPIOR2			;   (    Load/Store   lds/sts)
;.equ			= 0x07				;7 - 
;.equ			= 0x06				;6 - 
;.equ			= 0x05				;5 - 
;.equ			= 0x04				;4 - 
;.equ			= 0x03				;3 - 
;.equ			= 0x02				;2 - 
;.equ			= 0x01				;1 - 
;.equ			= 0x00				;0 - 
;******************************************************   
.def	PSREG		= r2
.def	zerro		= r3				;  0x00!!!
.def	full		= r4				;  0xFF!!!	
.def	Selectr		= r5				;    UOZ
.def	DeltaL		= r6				;  Seletr 
.def	DeltaH		= r7
.def	RaznostL	= r8				;       
.def	RaznostH	= r9

.def	N1L		= r10				;   -   ( )
.def	N1H		= r11				;   -   ( )
.def	N0L		= r12				;   -   ( )
.def	N0H		= r13				;   -   ( )
.def	NL		= r14				;   -  
.def	NH		= r15				;   -  

.def	temp		= r20				; 
.def	DH1Chain	= r21				;        
.def	DH2Chain	= r22				;        
.def	Events		= r23				; .      DH2,   DH1

.def	A		= r16				
.def	B		= r17				
.def	C		= r18		
.def	D		= r19   
;****************************************************** 
.Macro	store
.if	@0 < 0x40
	out	@0,@1         
.else
	sts	@0,@1
.endif
.EndMacro

.Macro	load
.if	@1 < 0x40
	in	@0,@1         
.else
	lds	@0,@1
.endif
.EndMacro

.Macro	pushSREG
	in	PSREG,SREG				
.EndMacro

.Macro	popSREG	
	out	SREG,PSREG
.EndMacro

.Macro	FTW
	ldi	A,High(@0)
	st	-X,A
	ldi	A,Low(@0)		
	st	-X,A
.EndMacro

.Macro	FTB
	ldi	A,@0
	st	-X,A
.EndMacro

.Macro	IncPtrA
	lds	A,@0
	inc	A
	sts	@0,A
.EndMacro

.Macro	SetDivPtrA
	ldi	A,Low(@0)		
	sts	DivPtr,A
	ldi	A,High(@0)
	sts	DivPtr+1,A
.EndMacro

.Macro	CopyLEDandDIP	;A,2
	ldi	@0,@1
	andi	@0,0x0F 
	sbic	PinD,7					
	sbr	@0,0x80
	sbic	PinB,0					
	sbr	@0,0x40
	sbic	PinB,1					
	sbr	@0,0x20
	sbic	PinB,2					
	sbr	@0,0x10
.EndMacro

.Macro	SetLEDCtrl
	load	A,ECoreSetup
	andi	A,0xf0
	ori 	A,@0
	store	ECoreSetup,A
.EndMacro

.Macro	SetDIPandLEDCtrl
	load	B,ECoreSetup
	sbrs	@0,7					; 7 ()   0,    
	cbr	B,(1<<ADCCanCorSelectr)                 ;      .equ	ADCCanCorSelectr= 4, 5, 6  7
	sbrs	@0,6					; 6    0,    
	cbr	B,(1<<ADCCanTblSelectr)                 ;       .equ	ADCCanTblSelectr= 4, 5, 6  7
	andi	B,0xF0					;    
                                                        ;       	
	.dw	0xf409                                  ; brne   +1 (sbrs	@0,5)
	sbi	CoreSetup,ADCDisableBit
	sbrs	@0,5                 			; 5    0,     
	sbi	CoreSetup,LoadDisableBit                ;     
;	sbrs	@0,4                 			
;	sbi	                
	andi	@0,0x0F                                  ; 
	add	B,A
	out	ECoreSetup,B                            ;    
.EndMacro

.Macro	pusha
	push	XL
	push	XH
	push	YL
	push	YH
	push	r0
	push	r1
	push	A
	push	B
	push	C
	push	D
.EndMacro

.Macro	popa
	pop	D
	pop	C
	pop	B
	pop	A                                           
	pop	r1
	pop	r0
	pop	YH
	pop	YL
	pop	XH
	pop	XL
.EndMacro

.Macro	StartDelta
	sts	TCCR1B,zerro				; -
	movw	N1H:N1L,N0H:N0L				;   
	lds	N0L,TCNT1L
	lds	N0H,TCNT1H 
	sts	TCNT1H,zerro				; -
	sts	TCNT1L,zerro								
	cbr	Status,LowMode				; 
	sbic	TIFR1,0					;   ,    	
	rcall	SetLowMode
	out	TIFR1,full				;   							
	ldi	temp,SystemClk			
	sts	TCCR1B,temp				; -
	sbr	EStatus,Delta                           ;~ProtectCount*ProtectClk + 6     
	ldi	temp,0x1F				
	mov	Selectr,temp
	sbrs	Status,LowModeBit                       ;     .    Delta!!!
	rcall	StartIgnition				;~50-70       . 
	sbis	CoreSetup,ADCDisableBit			; ,   
	rcall	ReadADC                                 ;~2 
.EndMacro 

.Macro	StopDelta
	sts	TCCR1B,zerro				; -
	lds	temp,TCNT1L	
	sbic	TIFR1,0					;   ,    
	mov	temp,full
	sts	MDelta,temp				
	lds	temp,TCNT1H 
	sbic	TIFR1,0					;   ,    
	mov	temp,full
	sts	MDelta+1,temp				
	sts	TCNT1H,zerro 				; -
	sts	TCNT1L,zerro	
	out	TIFR1,full				;   							
	ldi	temp,SystemClk			
	sts	TCCR1B,temp				; -
	cbr	EStatus,Delta                           ;~ProtectCount*ProtectClk + 6     
	sbis	CoreSetup,ADCDisableBit			; ,   
	rcall	StartADC				;~7 
	sbis	CoreSetup,LoadDisableBit		; ,    
	rcall	Load_Math
	rcall	SetService				;   
.EndMacro

.Macro	GetADC
        lds	@0,ADCAver+@1-4
.EndMacro

.Macro	LEDon		                		;    
	sbi	PortB,5
.EndMacro

.Macro	LEDoff		                		;    
	cbi	PortB,5
.EndMacro

.Macro	LEDrs		                		;         . LEDrs A,3
	sbrs	@0,@1		
	LEDoff
	sbrc	@0,@1		
	LEDon
.EndMacro

.Macro	LEDrc		                		;         . LEDrc A,3 
	sbrs	@0,@1		
	LEDon
	sbrc	@0,@1		
	LEDoff
.EndMacro

.Macro	LEDis		                		;          -. LEDis PINC,0 
.if	@0 < 0x40
	sbis	@0,@1		
	LEDoff
	sbic	@0,@1		
	LEDon
.else
	push	A
	load    A,@0
        LEDrs	A,@1
	pop	A
.endif
.EndMacro

.Macro	LEDic		                		;          -. LEDic PINC,0 
.if	@0 < 0x40
	sbis	@0,@1		
	LEDon
	sbic	@0,@1		
	LEDoff
.else
	push	A
	load    A,@0
        LEDrc	A,@1
	pop	A
.endif
.EndMacro

.Macro	lsrw
	lsr	@0H			
	ror	@0L						
.EndMacro

.Macro	lslw
	lsl	@0L						
	rol	@0H			
.EndMacro

.Macro	subiw    
	subi 	@0L,low(@1)	
	sbci	@0H,High(@1)
.EndMacro

.Macro	ldiw 
	ldi 	@0L,low(@1)
	ldi	@0H,High(@1)
.EndMacro

.Macro  ServiceADisable
 	sbi	CoreSetup,ServiceADisableBit		;  ServiceA
.EndMacro

.Macro  ServiceAEnable
 	cbi	CoreSetup,ServiceADisableBit		;  ServiceA
.EndMacro

.Macro  ServiceBDisable
 	sbi	CoreSetup,ServiceBDisableBit		;  ServiceB
.EndMacro

.Macro  ServiceBEnable
 	cbi	CoreSetup,ServiceBDisableBit		;  ServiceB
.EndMacro

.Macro  LoadDisable
 	sbi	CoreSetup,LoadDisableBit		;  
.EndMacro

.Macro  LoadEnable
 	cbi	CoreSetup,LoadDisableBit		;  
.EndMacro

.Macro  xchg
	push	@0
	push	@1
	pop	@0
	pop	@1			
.EndMacro

.Macro  fld	;fld	Reg,XYZ
	rcall	waitEEPE                
	out	EEARH,@1H
	out	EEARL,@1L
	sbi	EECR,EERE
	in	@0,EEDR
.EndMacro

.Macro  flds	;flds	Reg,Addr
	rcall	waitEEPE                
	ldi	@0,High(@1)
	out	EEARH,@0
	ldi	@0,Low(@1)
	out	EEARL,@0
	sbi	EECR,EERE
	in	@0,EEDR
.EndMacro

.Macro  fsts	;fsts	Addr,Reg
	push	r0
	mov	r0,@1
	flds	@1,@0
	cpse	r0,@1
	rcall	writebyte
	mov	@1,r0
	pop	r0
.EndMacro

.Macro  fst	;fst	XYZ,Reg
	push	r0
	fld	r0,@0
	xchg    r0,@1
	cpse	r0,@1
	rcall	writebyte
	pop	r0
.EndMacro


;*******************************************************************************
ResetCore:
	cli
	clr	zerro
	mov	full,zerro
	com	full
	ldiw	X,RAMEND
	out	SPL,XL
	out	SPH,XH
	in	A,MCUCR			
	cbr	A,PUD					;    PUD=0 (    )
	mov	B,A
	sbr	A,IVCE					;         IVCE=1
	out	MCUCR,A
	cbr	B,IVSEL					;IVSEL=0
	out	MCUCR,B
	out	DDRB,zerro				; 
	out	DDRC,zerro				; 
	out	DDRD,zerro				; 
	out	PORTB,full				;    +5 (PUD=0)
	out	PORTC,full				;    +5 (PUD=0)
	out	PORTD,full				;    +5 (PUD=0)
	sbi	DDRB,5					;  
	store   CoreSetup,zerro
	store   ECoreSetup,zerro
	ldi	A,(1<<ADCCanTblSelectr)+(1<<ADCCanCorSelectr)+(1<<ADCCanA)+(1<<ADCCanB)
	andi	A,0xF0					;      
        brne	res_1                                   ;       
	sbi	CoreSetup,ADCDisableBit
res_1:	load	B,ECoreSetup
	andi	B,0x0F
	add	A,B
	store	ECoreSetup,A
	sts	PLoad,zerro				;   
	sts	PLoad+1,zerro
	sts	PCorr,zerro				;    
	sts	PCorr+1,zerro
	sts	PCorr+2,zerro
	sts	FAcc,zerro
	sts	FA,full
	ldi	A,0x3
	sts	FA+1,A
	rcall	reset					;    CoreSetup    ECoreSetup
	ldi	A,0b00000101				;    DH1  DH2 (10-, 01-, 11-)
       	sts	EICRA,A		
	sbi	EIMSK,0 				; int0 
	sbis	CoreSetup,DH2DisableBit
	sbi	EIMSK,1 				; int1 ,     
	out	EIFR,full				;    int0  int1
	sts	TCCR1A,zerro				;    -   Normal (0)
	ldi	A,SystemClk				;   
	sts	TCCR1B,A	
        sts	TCNT1H,zerro                            ; -
        sts	TCNT1L,zerro
        sts	OCR1BH,full                             ; OCRB  
        sts	OCR1BL,full                             
        sts	OCR1AH,full                             ; OCRA  
        sts	OCR1AL,full                             
	ldi	A,0b00000110				;       OCRA   OCRB
	sts	TIMSK1,A	
	ldi	A,0b00000010		        	;      
	sts	TCCR2A,A				;  - CTC
	sts	TCCR2B,zerro				;  ( 2  )
	sts	TCNT2,zerro				;TC2 = 0
	ldi	A,ProtectClk<<1				;    
	dec	A					
	sts	OCR2A,A					;OCR2A=2*ProtectClk-1
	ldi	A,0x2					;      OCRA
	sts	TIMSK2,A	
	sbi	DDRD,PIND6				;      0
	ldi	A,0b01000010		
	out	TCCR0A,A			        ;  - CTC
	ldi	A,0b00000001		
	out	TCCR0B,A			        ;  0   16 
	ldi	A,Fn 					;F = 8/(1+Fn)
	out	OCR0A,A				
	ldiw	X,Index+64					;  Index
	rcall	FillIndex
	ldi	A,0x1F				
	mov	Selectr,A
	in	Status,PinD				;    
	andi	Status,DH2+DH1 				;Status=[0,0,0,0,DH2,DH1,0,0]
	sbic	CoreSetup,DH2DisableBit                 ;Ec  ,  0  .
	cbr	Status,DH2
	clr	Events					;    
	sbrc	Status,DH1Bit
	sbr	Events,DH1Event
	sbrc	Status,DH2Bit
	sbr	Events,DH2Event				;Events=[0,0,0,DH2,0,0,0,DH1]
	sbr	Status,LowMode+StopMode
	ldi	A,TblCount-1				;       
	sts	TblSelectr,A
	ldi	B,32
	mul	B,A
	ldiw	X,UOZ
	add	r0,XL
	adc	r1,XH
	sts	TblAddress,r0
	sts	TblAddress+1,r1

	sbr	D,0x80					;   
	sbis	PINB,3					;           
	rcall	FillAllTable                            ; (  )    
	sbrc    D,7					; -  EEPROM
	rcall	LoadAllTable    

	clr	EStatus
	sbis	CoreSetup,UARTDisableBit		; ,  UART 
	rcall	UARTInit				; UART
	load	A,ECoreSetup	                        ; . 
	andi	A,0xf0					;   
	sts	DIDR0,A					;     .	
	ldiw	X,ADCBuffers             		;  
	ldi	B,4*ADCBufferSize
	add	XL,B
	adc	XH,zerro
res_2:	FTB	0xFF
	dec	B
	brne	res_2
	sts	ADCptr,zerro                            ;      
	sts	ADCptrNew,zerro  

	ldi	A,4
	rcall	PreSetADC
	ldi	A,5
	rcall	PreSetADC
	ldi	A,6
	rcall	PreSetADC
	ldi	A,7
	rcall	PreSetADC


;	sts	ADCAver+0,zerro  			;    .
;	sts	ADCAver+1,zerro
;	sts	ADCAver+2,zerro
;	sts	ADCAver+3,zerro
;	sts	ADCAver+4,full
;	sts	ADCAver+5,full
;	sts	ADCAver+6,full
;	sts	ADCAver+7,full
	rcall	ADCProcessIFStopMode
	sts	tester,zerro
	sts	tester+1,zerro
	ldi	A,UOZMaxFP8
	sts	UOZCurrent+1,A
	sts	UOZCurrent,zerro
	ldiw	Z,VersionPtr*2
	ldiw	X,Version+1	
	clr	C
res_3:	inc	C
	lpm	A,Z+
	st	X+,A
	cpi	C,66
	breq	res_4
	tst	A
	brne	res_3
res_4:	sts	Version,C				;   
	SetDivPtrA DivX
	ldi	A,Ka
	cpi	A,2
	brne	res_5
	SetDivPtrA Div2
	rjmp	res_11
res_5:	cpi	A,4
	brne	res_6
	SetDivPtrA Div4
	rjmp	res_11
res_6:	cpi	A,8
	brne	res_7
	SetDivPtrA Div8
	rjmp	res_11
res_7:	cpi	A,16
	brne	res_8
	SetDivPtrA Div16
	rjmp	res_11
res_8:	cpi	A,32
	brne	res_9
	SetDivPtrA Div32
	rjmp	res_11
res_9:	cpi	A,64
	brne	res_10
	SetDivPtrA Div64
	rjmp	res_11
res_10:	cpi	A,128
	brne	res_11
	SetDivPtrA Div128
res_11:	ldiw	X,LoadBuffer             		;    
	ldi	B,LoadBufferSize
	add	XL,B
	adc	XH,zerro
res_12:	FTB	0x00
	dec	B
	brne	res_12
	sts	Loadptr,zerro                            ;     
        sei

;******************************************************  
LoopCore:
	rcall	LightSwitch
	rcall	ADCProcessIFStopMode
	ldi	C,0                                     ;    
	rcall	Averge
	ldi	C,1
	rcall	Averge
	sbis	CoreSetup,UARTDisableBit		; ,  UART 
	rcall	UARTMODE
	ldi	C,2
	rcall	Averge
	ldi	C,3
	rcall	Averge
	rcall	TblControl
	sbis	CoreSetup,UARTDisableBit		; ,  UART 
	rcall	UARTMODE
	sbis	CoreSetup,LoadDisableBit		; ,    
	rcall	Load_Averge

        rcall	loop
;   
	clr	C					
	cpi	C,ADCCanCorSelectr
	breq    LoopCore	
	GetADC	A,ADCCanCorSelectr               	;    ,   
	GetADC	D,ADCCanCorSelectr+4
	cp	A,D
	breq	LoopCore	

;    -CorrectFP16+fmul ADC,High(CorrectFP16)+High(fmul  ADC,Low(CorrectFP16))+256*C
	clr	XH
	clr	XL
	subiw	X,CorrectFP16               ;C:XH:XL
	sbc	C,zerro			
	ldi	D,High(CorrectFP16)	
	fmul	D,A
	add	XL,r0
	adc	XH,r1
	adc	C,zerro
	ldi	D,Low(CorrectFP16)	
	fmul	D,A
	brcc	LC_0
	ldi	D,1
	add	XH,D
	adc	C,zerro	
LC_0:	add	XL,r1
	adc	XH,zerro
	adc	C,zerro	
	sts	PCorr+2,C
	sts	PCorr+1,XH
	sts	PCorr,XL
	rjmp	LoopCore

PreSetADC:	;A= a 4,5,6,7
	ldiw	X,ADCAver
	add	XL,A
	adc	XH,zerro
	st	X,full	
	sbiw	X,4
	st	X,full
	cpi	A,ADCCanCorSelectr
	breq	PSA_1
	st	X,zerro	
PSA_1:  ret

LightSwitch:
	load	A,ECoreSetup
	andi	A,0x0f
	cpi	A,0x0
	brne	LC_1
	LEDoff
LC_1:	cpi	A,0x1
	brne	LC_2
	LEDrs	EStatus,DeltaBit
	ret	
LC_2:	cpi	A,0x2
	brne	LC_3
	LEDis PIND,2 
	ret	
LC_3:	cpi	A,0x3
	brne	LC_4
	LEDis PIND,3
	ret	
LC_4:	cpi	A,0x4
	brne	LC_5
	LEDis PINC,3 
	ret	
LC_5:	cpi	A,0x5
	brne	LC_6
	LEDis PINC,2
	ret	
LC_6:	cpi	A,0x6
	brne	LC_7
	LEDis PINC,1 
	ret	
LC_7:	cpi	A,0x7
	brne	LC_8
	LEDis PINC,0
	ret	
LC_8:	cpi	A,0x8
	brne	LC_9
	LEDrs	Status,StopModeBit
	ret	
LC_9:	cpi	A,0x9
	brne	LC_A
	LEDrs	Status,LowModeBit
	ret	
LC_A:	cpi	A,0xA
	brne	LC_B
	LEDrs	Status,UOZMinBit
	ret	
LC_B:	cpi	A,0xB
	brne	LC_C
	LEDrs	Status,UOZMaxBit
	ret	
LC_C:	cpi	A,0xC
	brne	LC_D
	LEDrs	EStatus,Ign1Bit	
	ret	
LC_D:	cpi	A,0xD
	brne	LC_E
	LEDrs	EStatus,Ign2Bit	
	ret	
LC_E:	cpi	A,0xE
	brne	LC_F
	LEDrs	Status,UARTCtrlBit
	ret	
LC_F:	cpi	A,0xF
	brne	LC_10
	LEDon
LC_10:	ret	

TblControl:	         				;     TblSelectr 
	sbrc	Status,UARTCtrlBit
	ret                                             
	GetADC	A,ADCCanTblSelectr                      ;   ,  
	GetADC	B,ADCCanTblSelectr+4
	cp	A,B
	breq	TC_exit
	ldi	B,TblCount
	mul	A,B                                     
	sts	TblSelectr,r1                           ;TblSelectr=High(ADC*TblCount)
	ldi	B,32
	mul	B,r1
	ldi	A,Low(UOZ)
	ldi	B,High(UOZ)
	add	r0,A
	adc	r1,B
	sts	TblAddress,r0
	sts	TblAddress+1,r1
TC_exit:ret
			
Averge:	mov	XL,full					;C=ADCCan
	andi	C,3
	load	A,ECoreSetup                            ;    	
	swap	A  					;    =0    
	mov	B,C
        inc	B  
AV0: 	ror	A
        dec	B
        brne	AV0
	brcc    AV3
	mov	XL,zerro
	mov	XH,zerro	
	mov	A,zerro
AV1:	ldi	B,4
	mul	A,B
	add	r0,C
	adc	r1,zerro	
	ldiw	Y,ADCBuffers
	add	YL,r0
	adc	YH,r1
	ld	B,Y
	add	XL,B
	adc	XH,zerro
	inc	A
	cpi	A,ADCBufferSize
	brne	AV1
	lsr	A
AV2:  	lsrw	X
	lsr	A
	brne	AV2
AV3:	mov	A,XL
	ldiw	Y,ADCAver
	add	YL,C
	adc	YH,zerro
	movw	XH:XL,YH:YL
	adiw	X,4
	ld	C,Y
	st	X,C
	st	Y,A
	ret

Load_Averge:
	mov	A,zerro
	mov	XL,zerro
	mov	XH,zerro	
	ldiw	Y,LoadBuffer
D_A1:	ld	B,Y+
	add	XL,B
	adc	XH,zerro
	inc	A
	cpi	A,LoadBufferSize
	brne	D_A1
	lsr	A
D_A2:  	lsrw	X
	lsr	A
	brne	D_A2
	ldi	A,High(LoadFP16) 
	mul	A,XL
	movw	YH:YL,r1:r0
	ldi	A,Low(LoadFP16)	
	mul	A,XL
	add	YL,r1
	adc	YH,zerro
	sts	PLoad+1,YH
	sts	PLoad,YL
	ret

Load_Math:						;       
	movw	ZH:ZL,N1H:N1L	
	sub	ZL,N0L
	sbc	ZH,N0H
	brcc	D_M1
	com	ZH
	com	ZL
	adiw	Z,1
D_M1:   tst	ZH
	breq	D_M2
	mov	ZL,full
D_M2:   mov	temp,full
	sub	temp,ZL
	push	A
	lds	A,LoadPtr
	inc	A
	andi	A,LoadBufferSize-1
	sts	LoadPtr,A	
	ldiw	Z,LoadBuffer
	add	ZL,A
	adc	ZH,zerro
	pop	A
`	st	Z,temp
	ret
;******************************************************      
LinesCNHG:						;  !!!!
	sbrc	Status,ProtectBit			;     ,  
	reti
	pushSREG
	ldi	temp,2					;0-off, 1-16MHz, 2-2MHz
	sts	TCCR2B,temp				;      
	sts	TCNT2,zerro                             ;TC2 = 0
	in	temp,PinD				;    (   )
	sbic	CoreSetup,DH2DisableBit                 ;Ec  ,  0  .
	cbr	temp,DH2
	ldi	DH1Chain,0b00000001			;     -   
	sbrs	temp,DH1Bit				;   -    
	com	DH1Chain				;PinX=0 ->  Chain=11111110
	ldi	DH2Chain,0b00000001			;PinX=1 ->  Chain=00000001
	sbrs	temp,DH2Bit
	com	DH2Chain
	sbr	Status,Protect		                ;    
	popSREG
	reti

ProtectLines:     
	sbrs	Status,ProtectBit			;     
	reti
	pushSREG	
	in	temp,PinD				;    
	sbic	CoreSetup,DH2DisableBit                 ;Ec  ,  0  .
	cbr	temp,DH2
	lsl	DH1Chain				
	andi	DH1Chain,exp2(ProtectCount+1)-1		;exp2(ProtectCount+1)-1 =      0b00001111
	sbrc	temp,DH1Bit	
	inc	DH1Chain	
	lsl	DH2Chain	
	andi	DH2Chain,exp2(ProtectCount+1)-1		;exp2(ProtectCount+1)-1 =      0b00001111
	sbrc	temp,DH2Bit				
	inc	DH2Chain				
CheckDH1Chain:						;     
	cp	DH1Chain,zerro			
	breq	CheckDH2Chain				;"" 0  .   
	cpi	DH1Chain,exp2(ProtectCount+1)-1		;exp2(ProtectCount+1)-1 =      0b00001111
	breq	CheckDH2Chain				;"" 1  .   
	popSREG
	reti
CheckDH2Chain:	
	cp	DH2Chain,zerro
	breq	CreateEvents				;"" 0  .   
	cpi	DH2Chain,exp2(ProtectCount+1)-1		;exp2(ProtectCount+1)-1 =      0b00001111
	breq	CreateEvents				;"" 1  .   
iret:	popSREG
	reti
CreateEvents:						
	sts	TCCR2B,zerro				;       							
	sts	TCNT2,zerro				;       
	cbr	Status,Protect				;  
	mov	temp,Status				;     
	andi	temp,DH1+DH2
	sbrc	DH1Chain,0
	subi	temp,DH1
	sbrc	DH2Chain,0	
	subi	temp,DH2				;  0,  !
	breq	iret					;  
	cbr	Status,DH1+DH2                          ;Status=[X,X,X,X,0,0,X,X]
	sbrc	DH1Chain,0
	sbr	Status,DH1
	sbrc	DH2Chain,0	
	sbr	Status,DH2				;Status=[X,X,X,X,DH2,DH1,X,X]
	lsl	Events					;   Events 
	cbr	Events,DH1Event+DH2Event                ;Events=[DH2(n-3),DH2(n-2),DH2(n-1),0,DH1(n-3),DH1(n-2),DH1(n-1),0]		
	sbrc	Status,DH1Bit						
	sbr	Events,DH1Event				
	sbrc	Status,DH2Bit
	sbr	Events,DH2Event				;Events=[DH2(n-3),DH2(n-2),DH2(n-1),DH2,DH1(n-3),DH1(n-2),DH1(n-1),DH1]		
	ldi	temp,StopTime
	sts	StopCnt,temp
	cbr	Status,StopMode				;  
	rcall	Actions
	popSREG
	reti

;******************************************************   
IgnitionInt:
	sbrc	Status,StopModeBit	
	reti	
	pushSREG					;  .      
	lds	temp,StopCnt
	dec	temp
	sts	StopCnt,temp
	brne	II_1
	sbr	Status,StopMode				; 
	cbr	EStatus,Delta
	sts	MDelta,full
	sts	MDelta+1,full
	rcall	SetLowMode
	popSREG
	reti
II_1:	sbic	TIFR1,0					;   ,    	
	rcall	SetLowMode
	sbrs	EStatus,DeltaBit
	rjmp	II_2
	sbrs	Status,LowModeBit	
	rcall	Ignition
	popSREG
	reti
II_2:   sbis	CoreSetup,ServiceADisableBit
	rcall	ServiceA	
	popSREG
	reti

;****************************************************************
SetService:
	push	A
	push	YH                                      
	push	YL                                      
	lds	YL,MDelta                               
	lds	YH,MDelta+1                             
	push	XH					
	push	XL        
	ldiw    X,Alfa
	push	r1
	push	r0
	mul	XL,YL
	mov	ZL,r1					
	mul	XH,YH
	mov	temp,r1
	mov	ZH,r0					
	mul	XL,YH
	add	ZL,r0	
	adc	ZH,r1
	adc	temp,zerro
	mul	XH,YL
	add	ZL,r0	
	adc	ZH,r1
	adc	temp,zerro                              ;temp:ZH:ZL
;         
	subiw	Z,INT((ProtectCount*ProtectClk+6)*8/(1+Fn)+0.5)
	sbc	temp,zerro                      	;temp:ZH:ZL        
	brcc	SOB_M1
	mov	ZL,zerro
	mov	ZH,zerro
	mov	temp,zerro
SOB_M1:	lds	XL,TCNT1L				
	lds	XH,TCNT1H
	adiw	X,1
	cp	XL,ZL
	cpc	XH,ZH
	cpc	zerro,temp
	brcs	SOB_M2
	mov	ZL,full
	mov	ZH,full
	mov	temp,zerro
	rcall	Service
	sts	OCR1BH,full
	sts	OCR1BL,full                              
	rjmp	SOB_0

SOB_M2:	sbic	CoreSetup,C3734DisableBit		; ,    
	rjmp	SOB_0

	sbrc	Status,LowModeBit			; ,   
	rjmp	SOB_0

	lds	A,OCR1AL
	add	ZL,A
	lds	A,OCR1AH
	adc	ZH,A
	adc	temp,zerro
	sub	ZL,YL
	sbc	ZH,YH
	sbc	temp,zerro				;temp:ZH:ZL

SOB_0:	pop	r0
	pop	r1
	pop	XL
	pop	XH                                      
	pop	YL
	pop	YH
	pop	A

SetEOCR1B:
	tst	temp
	breq    SOB_1
	cbr	EStatus,EOCR1BEmpty
	sts	OCR1BH,full
	sts	OCR1BL,full                              
;	sub	ZL,full
;	sbc	ZH,full
;	sbc	temp,zerro
	dec	temp
	sts	EOCR1B+2,temp
	sts	EOCR1B+1,ZH
	sts	EOCR1B,ZL
	ret
SOB_1:	sts	OCR1BH,ZH                               
	sts	OCR1BL,ZL                               
	sbr	EStatus,EOCR1BEmpty
	ret

ServiceInt:
	pushSREG
	sbrc	EStatus,DeltaBit
	rjmp	SInt_1
	sbrc	EStatus,EOCR1BEmptyBit
	rcall	Service	
	sbrc	EStatus,EOCR1BEmptyBit
	store	OCR1BH,full	
	sbrc	EStatus,EOCR1BEmptyBit
	store	OCR1BL,full
	sbrc	EStatus,EOCR1BEmptyBit
	rjmp	SInt_2
	lds	ZL,EOCR1B
	lds	ZH,EOCR1B+1
	lds	temp,EOCR1B+2
	rcall	SetEOCR1B
	popSREG
	reti		
SInt_1:	sbis	CoreSetup,ServiceBDisableBit
	rcall	ServiceB
SInt_2:	popSREG
	reti		

SetLowMode:
	sbr	Status,LowMode				; " "
	ldi	temp,UOZMaxFP8
	sts	UOZCurrent+1,temp
	sts	UOZCurrent,zerro
	mov	N0L,full
	mov	N0H,full
	movw	N1H:N1L,N0H:N0L				;   
	movw	NH:NL,N0H:N0L	
	ret

CalculateAverage:
	clr	temp
	add	NL,N1L
	adc	NH,N1H
	adc	temp,zerro
	asr	temp
	ror	NH
	ror	NL
	ret

StartIgnition:  					;     "" 
	movw	NH:NL,N0H:N0L				;  ,  N =  
	sbis	CoreSetup,AverageDisableBit             ;       N
	rcall	CalculateAverage
	ldiw	Z,Index					;FindSelectr
	mov	Selectr,full                            ;      
FS_1:	inc	Selectr
	ld	RaznostL,Z+
	ld	RaznostH,Z+
	movw	DeltaH:DeltaL,RaznostH:RaznostL
	sub	RaznostL,NL
	sbc	RaznostH,NH
	brcs	FS_1
	ld	temp,-Z			
	ld	temp,-Z			
	ld	temp,-Z
	push	temp			
	ld	temp,-Z
	sub	DeltaL,temp
	pop	temp
	sbc	DeltaH,temp
	dec	Selectr
; 2 ( 2) - Code = N * [Yp*Raznost/Delta + Yk *(1-Raznost/Delta)] / Ka 
	pusha
	sbrs	Selectr,0x7				;    Selectr=0xff
	rjmp	SI_0				        ;    ,          
	lds	ZL,TblAddress                           ;   
	lds	ZH,TblAddress+1
	ld	B,Z					;      UOZ ( )
	clr	A
	rjmp	SI_3
SI_0:	clr	C						
	clr	A
	clr	B
	clr	D
	ldi	temp,24
SI_1:	lsl	C
	rol	RaznostL
	rol	RaznostH
	rol	A
	rol	B
	rol	D
	cp	A,DeltaL
	cpc	B,DeltaH
	cpc	D,zerro
	brcs	SI_2
	inc	C
	sub	A,DeltaL
	sbc	B,DeltaH
	sbc	D,zerro
SI_2:	dec	temp
	brne	SI_1
	lsr	RaznostL
	ror	C
	ldi	B,0b10000000				;C=(n-p)/Delta
	sub	B,C					;B=1-(n-p)/Delta
	lds	ZL,TblAddress                            ;   
	lds	Zh,TblAddress+1
	add	ZL,Selectr              		;      :
	adc	ZH,zerro
	ld	A,Z+					;Yp
	fmul	A,C
	push	r1
	push	r0
	ld	A,Z					;Yk
	fmul	A,B
	pop	A
	add	A,r0
	pop	B
	adc	B,r1
;FP16 UOZCurrent(B:A) = Yp*Raznost/Delta + Yk *(1-Raznost/Delta)
SI_3:	cbr	Status,UOZMax+UOZMin
	clr	C					
	sbrc	Selectr,7				;    ,  
	rjmp	SI_4
;  
	lds	D,PLoad
	add	A,D
	lds	D,PLoad+1
	adc	B,D
	adc	C,zerro
;   
SI_4:	lds	D,PCorr
	add	A,D
	lds	D,PCorr+1
	adc	B,D
	lds	D,PCorr+2
	adc	C,D
	sbrc    C,7           				
	rjmp    CB_0                                    ;   - 
	breq	CheckBounds
	ldi	B,UOZMaxFP8	
	clr	A
	sbr	Status,UOZMax
	rjmp	MULTI
CheckBounds:
	ldi	C,UOZMinFP8				;      UOZMinFP8....UOZMaxFP8
	sub	C,B			
	brcs	CB_1
CB_0:	ldi	B,UOZMinFP8
	clr	A
	sbr	Status,UOZMin
	rjmp	MULTI
CB_1:	ldi	C,UOZMaxFP8
	sub	C,B			
	breq	CB_EQ
	brcc	MULTI
CB_EQ:	ldi	B,UOZMaxFP8	
	clr	A
	sbr	Status,UOZMax
; 2 ( 2) - Code = N * [Yp*Raznost/Delta + Yk *(1-Raznost/Delta)] / Ka
MULTI:	sts	UOZCurrent,A
	sts	UOZCurrent+1,B
	mul	A,NL					
	movw	X,r1:r0				
	mul	B,NH
	movw	Y,r1:r0				
	mul	B,NL					
	add	XH,r0					
	adc	YL,r1					
	adc	YH,zerro				
	mul	A,NH					
	add	XH,r0					
	adc	YL,r1					
	adc	YH,zerro				;Y:X
;      Ka
	lds	ZL,DivPtr
	lds	ZH,DivPtr+1
	icall          
;         .
	subiw	Y,int((ProtectCount*ProtectClk+6)*8/(1+Fn)+0.5)
	brcc 	CB_41
	mov	YH,zerro
	mov	YL,zerro
CB_41:	sts	OCR1AH,YH
	sts	OCR1AL,YL
;  (  2    )     ,    
	lds	XL,TCNT1L				
	lds	XH,TCNT1H
	adiw	X,2
	sub	YL,XL
	sbc	YH,XH
	brcc 	CB_5
	sbr	Status,UOZMin				;!!!   !!!
	rcall	UOZMinError
CB_5:	popa
	ret
;      Ka
;   15          - 68  
;************************************* Ka  
DivX:	ldi	A,Ka>>1
	clr	C 
	clr	D         
	ldi	B,16   
CB_3:	lsl	YL    
	rol	YH    
	rol	C      
	rol	D
	sub	C,A	   
	sbc	D,zerro 
	ori	YL,0x01
	brcc	CB_4
	add	C,A   
	adc	D,zerro
	andi	YL,0xFE     
CB_4:	dec	B         
	brne	CB_3
	ret
Div128:	lsrw	Y			;Ka=128
Div64:	lsrw	Y			;Ka=64
Div32:	lsrw	Y			;Ka=32
Div16:	lsrw	Y			;Ka=16
Div8:	lsrw	Y			;Ka=8
Div4:	lsrw	Y			;Ka=4
Div2:	ret				;Ka=2			

;******************************************************    
ReadADC:push	YH
	push	YL
	push	A
	ldiw	Y,ADCBuffers
	lds	A,ADCptr
	add	YL,A
	adc	YH,zerro
	lds	A,ADCH					;         
	st	Y,A
	lds	A,ADCPtrNew                             ;    
	sts	ADCPtr,A
	andi	A,3 					
	sbr	A,(1<<REFS0)+(1<<ADLAR)+(1<<MUX2)	;Uref=Vcc ADLAR=1  C    4
	sts	ADMUX,A                             	;   
	pop	A
	pop	YL
	pop	YH
	ret	

StartADC:						;   
	push	A
	push	B
	ldi	A,(1<<ADEN)+(1<<ADSC)+7			;      ~104 .   
	sts	ADCSRA,A				; 
RMA_1:	lds	A,ADCPtrNew		
	inc	A
	andi	A,4*ADCBufferSize-1
	sts	ADCPtrNew,A	
	load	B,ECoreSetup                            ;    	
	swap	B  					;    =0   .
	andi	A,3 					
        inc	A              
RMA_2:  ror	B
        dec	A
        brne	RMA_2
        brcc    RMA_1
        pop	B
	pop	A
	ret

ADCProcessIFStopMode:		
	sbrs	Status,StopModeBit                      ;    
	ret		
	sbic	CoreSetup,ADCDisableBit			; ,   			
	ret					
	rcall	StartADC
waitADCRdy:
	lds	A,ADCSRA
	sbrc	A,ADSC					
	rjmp	waitADCRdy
	rcall	ReadADC
	ret	

;******************************************************    EEPROM
FillAllTable:
	ldiw	Z,(FillTable+65)*2
	ldiw	X,0
	ldi	A,TblCount
	ldi	B,32
	mul	A,B
	movw	YH:YL,r1:r0
	sbr	D,0x80				;   
FAT_1:	lpm	A,Z+
	add	XL,A
	adc	XH,zerro
	sbiw	Y,1
	brne	FAT_1
       	sbiw	X,0				;    0
	breq	FAT_3
	lpm	A,Z+	
	sub	XL,A
	lpm	A,Z+
	sbc	XH,A
	sbiw	X,0
	brne	FAT_3
	cbr	D,0x80				;  
	ldiw	Z,(FillTable+65)*2
	ldiw	X,UOZ
	ldi	A,TblCount
	ldi	B,32
	mul	A,B
	movw	YH:YL,r1:r0
FAT_2:	lpm	A,Z+
	st	X+,A
	sbiw	Y,1
	brne	FAT_2
;	rcall	SaveAllTable
FAT_3:	ret


waitEEPE:
	sbic	EECR, EEPE        	;   FLASH
	rjmp	waitEEPE
	ret

writebyte:
	cli
	rcall	waitEEPE
	out	EEDR,r0
	sbi	EECR,EEMPE
	sbi	EECR,EEPE
	rcall	waitEEPE
	sei
	ret

;    D  FLASH c     UOZMinFP8....UOZMaxFP8
LoadTable:
	pusha
	andi	D,TblCount-1
	ldi	B,32
	mul	B,D
	movw	YH:YL,r1:r0
	ldiw	X,UOZ
	add	XL,YL
	adc	XH,YH
LT_1:	fld	D,Y
	adiw	Y,1
	ldi	A,UOZMinFP8	
	sub	A,D		
	brcs	LT_2
	ldi	D,UOZMinFP8
LT_2:	ldi	A,UOZMaxFP8		
	sub	A,D		
	brcc	LT_3
	ldi	D,UOZMaxFP8	
LT_3:	st	X+,D
	dec	B
	brne	LT_1
	popa
	ret

;    FLASH    UART   
LoadAllTableOverUART:
	push	B
	push	D
	ldi	B,TblCount-1
LATU_1:	ldi	D,0xC0
	add	D,B
	rcall	AddUARTCommand
	subi	B,1
	brcc	LATU_1
	pop	D
	pop	B
	ret
;    FLASH 
LoadAllTable:
	push	D
	ldi	D,TblCount-1
LAT_1:	rcall	LoadTable
	subi	D,1
	brcc	LAT_1
	pop	D
	ret
; ( )    D (       )
ResetTable:	
	pusha				
	andi	D,TblCount-1
	inc	D
	ldiw	X,UOZ
	ldi	A,32
	mul	A,D
	add	XL,r0
	adc	XH,r1
	rcall	FillTable
	popa
	ret
;      (   FLASH)
ResetAllTables:
	push	D
	ldi	D,TblCount-1
RAT_1:	rcall	ResetTable		
	subi	D,1
	brcc	RAT_1
	pop	D
	ret	
;     D(5)    FLASH
WriteTable:    
	pusha
	andi	D,TblCount-1
	ldi	B,32
	mul	B,D
	movw	YH:YL,r1:r0
	ldiw	X,UOZ
	add	XL,YL
	adc	XH,YH
WT_1:	ld	D,X+
	fst	Y,D
	adiw	Y,1
	dec	B
	brne	WT_1
	popa
	ret

SaveAllTable:
	push	D
	ldi	D,TblCount-1
SAT_1:	rcall	WriteTable
	subi	D,1
	brcc	SAT_1
	pop	D
	ret	

;******************************************************    UART
UARTInit:	
	ldi	A,207	   		;16-115 207-9600
	sts	UBRR0L,A
	sts	UBRR0H,zerro
; UCSR0A - USART Control and Status Register A
;.equ	MPCM0	= 0	; Multi-processor Communication Mode
;.equ 1	U2X0	= 1	; Double the USART transmission speed
;.equ	UPE0	= 2	; Parity Error
;.equ	DOR0	= 3	; Data overRun
;.equ	FE0	= 4	; Framing Error
;.equ	UDRE0	= 5	; USART Data Register Empty
;.equ	TXC0	= 6	; USART Transmitt Complete
;.equ	RXC0	= 7	; USART Receive Complete
	ldi	A,0b00000010
	sts	UCSR0A,A
; UCSR0B - USART Control and Status Register B
;.equ	TXB80	= 0	; Transmit Data Bit 8
;.equ	RXB80	= 1	; Receive Data Bit 8
;.equ	UCSZ02	= 2	; Character Size
;.equ 1	TXEN0	= 3	; Transmitter Enable
;.equ 1	RXEN0	= 4	; Receiver Enable
;.equ	UDRIE0	= 5	; USART Data register Empty Interrupt Enable
;.equ	TXCIE0	= 6	; TX Complete Interrupt Enable
;.equ 1	RXCIE0	= 7	; RX Complete Interrupt Enable
	ldi 	A,0b10011000
	sts	UCSR0B,A
;.equ	UCPOL0	= 0	; Clock Polarity
;.equ 1	UCSZ00	= 1	; Character Size
;.equ 1	UCSZ01	= 2	; Character Size           UCSZ01=0 -> UCSR0B
;.equ	USBS0	= 3	; Stop Bit Select
;.equ	UPM00	= 4	; Parity Mode Bit 0
;.equ	UPM01	= 5	; Parity Mode Bit 1
;.equ	UMSEL00	= 6	; USART Mode Select		00 -  
;.equ	UMSEL01	= 7	; USART Mode Select		01 -  
	ldi 	A,0b00000110 
	sts	UCSR0C,A
	rcall	ResetUart
	ret

RX_OK:	pushSREG			;      UART  
	push	D
	lds	D,UDR0
	tst	D			;   0 -   UART 
	brne	RX_OK_1		
	rcall	ResetUart
	pop	D
	popSREG
	reti
RX_OK_1:rcall	AddUARTCommand
	pop	D
	popSREG
	reti
ResetUart:	
	sts	RptrI,zerro
	sts	RptrO,zerro
	sts	TptrI,zerro
	sts	TptrO,zerro
	sts	TableUART,zerro
	cbr	EStatus,TnotEmpty+RnewCMD+RError+TError
	ret
CheckUARTflags:	
	push	A
	push	B
	cbr	EStatus,RnewCMD+TnotEmpty
	sbr	EStatus,RError+TError
	lds	A,RptrI
	lds	B,RptrO
	cpse	A,B	
	sbr	EStatus,RnewCMD
	inc	A
	cpse	A,B	
	cbr	EStatus,RError
	lds	A,TptrI     
	lds	B,TptrO     
	cpse	A,B		
	sbr	EStatus,TnotEmpty
	inc	A
	cpse	A,B	
	cbr	EStatus,TError
	pop	B
	pop	A
	ret	

AddUARTCommand:	
	rcall	CheckUARTflags
	sbrc	EStatus,RErrorBit	;   -   
	ret
	push	XH
	push	XL
	push	A
	IncPtrA	RptrI	
	ldiw	X,RBuff
	add	XL,A
	adc	XH,zerro
	pop	A
	st	X,D
	pop	XL
	pop	XH
	sbr	EStatus,RnewCMD		;   !
	ret

SendData:				;D -   
	push	YL
	push	YH
	push	A
	push	B
SD_1:	rcall	TransmiteData 
	rcall	CheckUARTflags
	sbrc	EStatus,TErrorBit	;   
	rjmp	SD_1
	ldiw	Y,TBuff
	IncPtrA	TptrI
	add	YL,A
	adc	YH,zerro
	st	Y,D
	pop	B
	pop	A
	pop	YH
	pop	YL
	ret

TransmiteData:
	rcall	CheckUARTflags
	sbrs	EStatus,TnotEmptyBit	;     
	ret
	lds	B,UCSR0A                ;    
	sbrs	B,UDRE0	
	ret				;    
	ldiw	Y,TBuff
	IncPtrA	TptrO
	add	YL,A
	adc	YH,zerro
	ld	B,Y
	sts	UDR0,B                  ; 
	ret

ReadCmd:rcall	CheckUARTflags
	sbrs	EStatus,RnewCMDBit	;   , 
	ret
	ldiw	X,RBuff
	IncPtrA RptrO       
	add	XL,A
	adc	XH,zerro
	ld	D,X
	rcall	ExecuteCmd
	ret

UARTMODE:
	rcall	TransmiteData  //Y,B,A
	rcall	CheckUARTflags
	rcall	ReadCmd
	ret

ExecuteCmd:				;D -  
;E0+D(5)  ( )    D(5) (   FLASH)
	push	D			;D -  
	andi	D,0xE0			;   E0+
	cpi	D,0xE0
	pop	D		
	brne	CmdC0
	rcall	ResetTable	
	ret
;C0+D(5)      D(5)  FLASH  
CmdC0:	push	D			;D -  
	andi	D,0xE0			;   C0+
	cpi	D,0xC0
	pop	D		
	brne	CmdA0
	rcall	LoadTable
	ret
;A0+D(5)      D(5)   FLASH
CmdA0:	push	D			;D -  
	andi	D,0xE0			;   A0+
	cpi	D,0xA0
	pop	D		
	brne	Cmd80
	rcall	WriteTable
	ret
;80+D(5)    
Cmd80:	push	D			;D -  
	andi	D,0xE0			;   80+
	cpi	D,0x80
	pop	D		
	brne	Cmd60
	push	D
	andi	D,TblCount-1
	sts	TblSelectr,D
	ldi	B,32
	mul	D,B
	ldiw	X,UOZ
	add	r0,XL
	adc	r1,XH
	sts	TblAddress,r0
	sts	TblAddress+1,r1
	sbr	Status,UARTCtrl
	pop	D
	ret
;60+D(5)      D(5)
Cmd60:	push	D			;D -  
	andi	D,0xE0			;   80+
	cpi	D,0x60
	pop	D		
	brne	Cmd40
	rcall	SendData
	andi	D,TblCount-1
	ldi	A,32
	mul	D,A			;r1:r0 -  
	mov	D,A
	rcall	SendData
	ldiw	X,UOZ
	add	XL,r0
	adc	XH,r1
Cmd60_1:ld	D,X+
	rcall	SendData
	ldi	D,1
	add	r0,D
	adc	r1,D
	dec	A
	brne	Cmd60_1
	ret
;40+A(5)       
Cmd40:	push	D			;D -  
	andi	D,0xE0			;   80+
	cpi	D,0x40
	pop	D		
	brne	Cmd30
	andi	D,0x1F
	sts	TableUART,D		
	ret
;30+D(4)          
Cmd30:	push	D			;D -  
	andi	D,0xF0			;   80+
	cpi	D,0x30
	pop	D		
	brne	Cmd20
	lds	XL,TblAddress
	lds	XH,TblAddress+1
	lds	A,TableUART
	add	XL,A
	adc	XH,zerro
	andi	D,0x0F
	swap	D
	ld	A,X
	andi	A,0x0F
	add	A,D
   	st	X,A
	ret
;20+D(4)          
Cmd20:	push	D			;D -  
	andi	D,0xF0			;   80+
	cpi	D,0x20
	pop	D		
	brne	Cmd10
	lds	XL,TblAddress
	lds	XH,TblAddress+1
	lds	A,TableUART
	add	XL,A
	adc	XH,zerro
	ld	A,X
	andi	A,0xF0
	andi	D,0x0F
	add	A,D
   	st	X,A
	ret
;10+D(4)        ECoreSetup
Cmd10:	push	D			;D -  
	andi	D,0xF0			;   10+
	cpi	D,0x10
	pop	D		
	brne	CmdF
	andi	D,0x0F
	load	A,ECoreSetup
	andi	A,0xF0
	add	A,D
	store	ECoreSetup,A
	ret

;F         VersionLength, UOZMinFP8, UOZMaxFP8, LDelta, 
;Base(HL), Fn, Ka, TblCount, LDeltaFP16(HL), CoreSetup, ECoreSetup, LBetta, LBettaFP16(HL)
CmdF:	cpi	D,0x0F
	brne	CmdE
	rcall	SendData
	ldi	D,16
	rcall	SendData
	lds	D,Version
	rcall	SendData
	ldi	D,UOZMinFP8
	rcall	SendData
	ldi	D,UOZMaxFP8
	rcall	SendData
	ldi	D,int(_Delta)
	rcall	SendData
	ldi	D,High(Base)
	rcall	SendData
	ldi	D,Low(Base)
	rcall	SendData
	ldi	D,Fn
	rcall	SendData
	ldi	D,Ka
	rcall	SendData
	ldi	D,TblCount
	sbr	D,0x80					;   Flash 
	rcall	SendData
	ldi	D,High(int(frac(_Delta)*32768+0.5))
	rcall	SendData
	ldi	D,Low(int(frac(_Delta)*32768+0.5))
	rcall	SendData
	load	D,CoreSetup
	rcall	SendData
	load	D,ECoreSetup
	rcall	SendData
	ldi	D,int(_Betta)
	rcall	SendData
	ldi	D,High(int(frac(_Betta)*32768+0.5))
	rcall	SendData
	ldi	D,Low(int(frac(_Betta)*32768+0.5))
	rcall	SendData
	ret

;E       (   FLASH)
CmdE:	cpi	D,0x0E
	brne	CmdD
	rcall	ResetAllTables
	ret
;D     UART
CmdD:	cpi	D,0x0D
	brne	CmdC
	sbr	Status,UARTCtrl
	ret
;      FLASH c     UOZMinFP8....UOZMaxFP8
CmdC:	cpi	D,0x0C
	brne	CmdB
	rcall	LoadAllTable
	ret
;B     ()
CmdB:	cpi	D,0x0B
	brne	CmdA
	cbr	Status,UARTCtrl
	ret
;A      FLASH
CmdA:	cpi	D,0x0A
	brne	Cmd9
	rcall	SaveAllTable
	ret
;9        - tester(HL) + N1(HL)+ N0(HL)+ N1(HL)+ MDelta(HL)+ 4  
Cmd9:	cpi	D,0x09
	brne	Cmd8
	rcall	SendData
	ldi	D,12
	rcall	SendData
	lds	D,tester+0
	rcall	SendData
	lds	D,tester+1
	rcall	SendData
	mov	D,N1H
	rcall	SendData
	mov	D,N1L                            
	rcall	SendData
	mov	D,N0H
	rcall	SendData 
	mov	D,N0L
	rcall	SendData
	lds	D,MDelta+1
	rcall	SendData
	lds	D,MDelta
	rcall	SendData
	lds	D,ADCAver+0
	rcall	SendData
	lds	D,ADCAver+1
	rcall	SendData
	lds	D,ADCAver+2
	rcall	SendData
	lds	D,ADCAver+3
	rcall	SendData
	ret  
;8      Index
Cmd8:	cpi	D,0x08
	brne	Cmd7
	rcall	SendData
	ldi	D,64
	rcall	SendData
	ldiw	X,Index
	ldi	A,64
Cmd8_1:	ld	D,X+
	rcall	SendData
	dec	A
	brne	Cmd8_1
	ret
;7    
Cmd7:	cpi	D,0x07
	brne	Cmd6
	rcall	SendData
	ldiw	X,Version				;  
	ld	D,X+
	rcall	SendData
Cmd7_1:	ld	D,X+
	rcall	SendData
	tst	D
	brne	Cmd7_1
	ret
;6    
Cmd6:	cpi	D,0x06
	brne	Cmd5
	rcall	SendData
	ldi	D,32
	rcall	SendData
	lds	XL,TblAddress
	lds	XH,TblAddress+1
	ldi	A,32
Cmd6_1:	ld	D,X+
	rcall	SendData
	dec	A
	brne	Cmd6_1
	ret
;5  TableUART  
Cmd5:	cpi	D,0x05
	brne	Cmd4
	lds	D,TableUART
	sts	FAcc,D
	ret
;4   FLASH  TableUART
Cmd4:	cpi	D,0x04
	brne	Cmd3
	rjmp	FLASHCmd
;3  :   (HL)  
Cmd3:	cpi	D,0x03
	brne	Cmd2
	rcall	SendData
	ldi	D,3
	rcall	SendData
	lds	D,FA+1
	rcall	SendData
	lds	D,FA
	rcall	SendData
	lds	D,FAcc
	rcall	SendData
	ret
;2 
Cmd2:	cpi	D,0x02
	brne	Cmd1
	ret
;1  : N(HL) Selectr TblSelectr Status EStatus UOZCurrent(HL) TableAdress 
Cmd1:	cpi	D,0x01
	brne	Cmd0
	rcall	SendData
	ldi	D,9
	rcall	SendData
	cli	
	push	Status
	push	Selectr
	push	NL
	push	NH
sei
	pop	D	
	rcall	SendData
	pop	D	
	rcall	SendData        
	pop	D	
	rcall	SendData
	lds	D,TblSelectr
	rcall	SendData 
	pop	D	
	rcall	SendData
	rcall	CheckUARTflags
	mov	D,Estatus
	rcall	SendData
	lds	D,UOZCurrent+1
	rcall	SendData
	lds	D,UOZCurrent
	rcall	SendData
	lds	D,TableUART
	rcall	SendData
Cmd0:	ret  
;  

FLASHCmd:
	lds	D,TableUART
;18+D(3)	    D(3)  
FCmd18:	push	D
	andi	D,0x18			;   18+
	cpi	D,0x18
	pop	D		
	brne	FCmd10
	andi	D,0b00000111
	inc	D 
	rcall	pow2
	lds	D,FAcc
	or	D,A
	sts	FAcc,D
        ret
;10+D(3)	    D(3)  
FCmd10:
	push	D
	andi	D,0x10			;   18+
	cpi	D,0x10
	pop	D		
	brne	FCmdF
	andi	D,0b00000111
	inc	D 
	rcall	pow2
	com	A
	lds	D,FAcc
	and	D,A
	sts	FAcc,D
        ret

pow2:	mov	A,zerro
	sec
pow2_1:	rol	A
	dec	D
	brne	pow2_1
	ret


;F    
FCmdF:	cpi	D,0x0F
	brne	FCmdE
	sts	FAcc,full
	ret
;E    
FCmdE:	cpi	D,0x0E
	brne	FCmdD
	sts	FAcc,zerro
	ret
;D C     FLASH
FCmdD:	cpi	D,0x0D
	brne	FCmdC
	lds	XL,FA
	lds	XH,FA+1
	lds	D,FAcc
	fst	X,D
	ret
;C      FLASH 
FCmdC:	cpi	D,0x0C
	brne	FCmdB
	lds	XL,FA
	lds	XH,FA+1
	fld	D,X
	sts	FAcc,D
;B
FCmdB:	cpi	D,0x0B
	brne	FCmdA
	ret
;A 
FCmdA:	cpi	D,0x0A
	brne	FCmd9
	ret
;9 
FCmd9:	cpi	D,0x09
	brne	FCmd8
	ret
;8
FCmd8:	cpi	D,0x08
	brne	FCmd7
	ret
;7
FCmd7:	cpi	D,0x07
	brne	FCmd6
	ret
;6 DEC     FLASH (10 )
FCmd6:	cpi	D,0x06
	brne	FCmd5
	lds	XL,FA
	lds	XH,FA+1
	sbiw	X,1
	cpi	XH,0x3
	brcs	FCmd6_1
	mov	XL,zerro
	mov	XH,zerro
FCmd6_1:sts	FA,XL
	sts	FA+1,XH
	ret
;5 INC     FLASH (10 )
FCmd5:	cpi	D,0x05
	brne	FCmd4
	lds	XL,FA
	lds	XH,FA+1
	adiw	X,1
	cpi	XH,0x4
	brlo	FCmd5_1
	mov	XL,full
	ldi	XH,0x3
FCmd5_1:sts	FA,XL
	sts	FA+1,XH
	ret
;4   5      FLASH  
FCmd4:	cpi	D,0x04
	brne	FCmd3
	lds	XL,FA
	lsl	XL
	lsl	XL
	lsl	XL
	lds	XH,FAcc
	lsr	XH
	ror	XL
	lsr	XH
	ror	XL
	lsr	XH
	ror	XL
	sts	FA,XL
	sts	FA+1,XH
	ret
;3   5      FLASH  
FCmd3:	cpi	D,0x03
	brne	FCmd2
	lds	D,FA
	andi	D,0b11100000
	lds	A,FAcc
	add	D,A
	sts	FA,D
	ret
;2       FLASH
FCmd2:	cpi	D,0x02
	brne	FCmd1
	ldi	D,0x3
	sts	FA,full
	sts	FA+1,D
	ret
;1      FLASH (10 )
FCmd1:	cpi	D,0x01
	brne	FCmd0
	sts	FA,zerro
	sts	FA+1,zerro
FCmd0:	ret

; FLASH  

EndCoreCSeg:						;   